//
// Printer class modifications
//

#include "ratsoft.ch"

#include "FiveWin.ch"
#include "Objects.ch"


CLASS TbPrinter FROM TPrinter

   METHOD DrawBitmap( nRow, nCol, cBitmap, nWidth, nHeight, nRaster )

   MESSAGE FillRect(aCols, oBrush)  METHOD _FillRect( aCols, oBrush )

ENDCLASS

//
// Scales bmp to nWidth, nHeight, which are passed in mm
//
METHOD DrawBitmap( nRow, nCol, xBitmap, nWidth, nHeight, nRaster, lHCtr, lVCtr ) CLASS TbPrinter

   local hDib      := NIL ,;
         hPal      := NIL ,;
         nAct      := NIL ,;
         nActMM    := NIL ,;
         nFactor   := NIL ,;
         nWNew     := NIL ,;
         nHNew     := NIL ,;
         nWNewMM   := NIL ,;
         nHNewMM   := NIL ,;
         lContinue := TRUE,;
         hBmp      := NIL ,;
         hBmpPal   := NIL

   DEFAULT( lHCtr, "L", FALSE )  // Centre image at coords passed
   DEFAULT( lVCtr, "L", FALSE )

   if ( valtype( xBitmap ) == "N" )

      hBmp     := LoadBitmap( GetInstance(), xBitmap )
      hBmpPal  := PalBmpLoad( xBitmap )
      hDib     := DibFromBitmap( hBmp, nHiWord( hBmpPal ) )

   else
      if file( xBitmap )
         hDib := DibRead( xBitmap )
      else
         lContinue := FALSE
      endif
   endif


   if lContinue

      if !::lMeta
         hPal = DibPalette( hDib )
      endif

      // Scale the width and height
      nAct  := DibWidth( hDib )             // Actual width in PIXELS
      if ( nWidth == NIL )
         nWNew := nAct
      else
         nActMM   := nAct / ::nLogPixelX() * 25.4 // Actual width in mm
         nFactor  := nWidth / nActmm              //
         nWNew    := nAct * nFactor
      endif

      nAct  := DibHeight( hDib )
      if ( nHeight == NIL )
         if lVCtr
            // Use factor from width
            nHNew    := nAct * nFactor
         else
            nHNew    := nAct
         endif
      else
         nActMM   := nAct / ::nLogPixelY() * 25.4
         nFactor  := nHeight / nActmm
         nHNew    := nAct * nFactor
      endif

      // And centre
      if lHCtr
         nCol -= ( nWNew / 2 )
      endif

      if lVCtr
         nRow -= ( nHNew / 2 )
      endif

      // And draw
      DibDraw( ::hDCOut, hDib, hPal, nRow, nCol,;
               nWNew, nHNew, nRaster )

      GlobalFree( hDib )
      if ! ::lMeta
         DeleteObject( hPal )
      endif

   endif

Return( NIL )


METHOD _FillRect ( aCols, oBrush ) CLASS TPrinter

   FillRect( ::hDCOut ,aCols, oBrush:hBrush )

RETURN( NIL )


