//
// Test the FW GDI funcs
//

// Include "FiveWin.ch" would obviate these individually
#include "Print.ch"
#include "WinApi.ch"
#include "Colors.ch"

// This is obviously application specific
#define BMP_RATSOFT           180

// Misc defines
#define PR_JUST_LEFT          "L"
#define PR_JUST_RIGHT         "R"
#define PR_JUST_CENTRE        "C"

#define LINE_HORIZONTAL       1
#define LINE_VERTICAL         2
#define LINE_DIAGONAL         3

#define LINE_NONE             0
#define LINE_SINGLE           1
#define LINE_DOTTED           3
#define LINE_HAIR             4
#define LINE_DASHED           5
#define LINE_THIN             6
#define LINE_DOUBLE           7

#define SHADE_LIGHT           5
#define SHADE_MEDIUM          40
#define SHADE_DARK            90

#define CRLF chr(13)+chr(10)


//
//
//
function Test()

   local nRow     := NIL ,;
         cTmp     := NIL ,;
         oPrn     := NIL ,;
         nTmp     := NIL ,;
         nCol     := NIL ,;
         nBottom  := NIL ,;
         nRight   := NIL ,;
         nB       := NIL ,;
         nR       := NIL ,;
         i        := NIL ,;
         cMemo    := NIL

   // Start
   pr_Reset()
   oPrn := pr_Config()

    //pr_Landscape( .f. )

   nTmp := SetBkMode( oPrn:hDC, 1 )
   //pr_Say( 15, 15, "SetBkMode returned "+ltrim(str(nTmp)) )


   // Page margin box
   //pr_Box( 10, 10, pr_PageHeight()-10, pr_PageWidth()-10, LINE_SINGLE )
   pr_Box( 10, 20, pr_PageHeight()-10, pr_PageWidth()-10, LINE_SINGLE )

   // Some text
   pr_SetFont( NIL, 12 )                 // Defaults to TNR
   pr_Say( 40, 15, "This is 12 pt font" )

   pr_SetFont( NIL, 24 )
   pr_Say( 45, 15, "This is 24 pt font" )

   pr_SetFont( "Arial", 36 )
   pr_Say( 55, 15, "This is 36 pt Arial" )

   pr_SetFont( "Times New Roman", 72 )
   pr_Say( 65, 15, "This is 72 pt" )

   // A big A
   pr_SetFont( "Times New Roman", 512 )
   pr_Say( 155, 15, "A" )


   // Right justify text at page border
   cTmp := "Elisabethstrae Mnchen"
   pr_SetFont( NIL, 12, .t.  )
   // pr_Say( 45, pr_PageWidth() - 10, cTmp, PR_JUST_RIGHT )
   //
   cTmp := oemtoansi( "Elisabethstrae Mnchen (oem2ansi)" )
   pr_Say( 50, pr_PageWidth() - 10, cTmp, PR_JUST_RIGHT )
   //
   // cTmp := ansitooem( "Elisabethstrae Mnchen (ansi2oem)" )
   // pr_Say( 55, pr_PageWidth() - 10, cTmp, PR_JUST_RIGHT )

   // Diagonal line
   pr_Line( 10, 10, 70, NIL, LINE_DIAGONAL )

   // Simple box
   pr_Box( 100, 100, 150, 150, LINE_SINGLE, NIL )

   // Bitmap
   //pr_Say(    115, 115, "Resources > " )
   //pr_BitMap( 110, 140, BMP_RATSOFT,  40,  13, 0  )

   pr_Say(    135, 115, "Disk file > " )
   pr_BitMap( 130, 140, "ratsoft.bmp",  40,  13 )

   // Shaded text
   pr_SetFont( NIL, 12 )

   pr_Say( 105, 10, "This text is shaded light" )
   pr_Rectangle( 105, 15, 120, 65, SHADE_LIGHT )

   pr_Say( 120, 15, "This text is shaded medium" )
   pr_Rectangle( 120, 15, 135, 65, SHADE_MEDIUM )

   pr_Rectangle( 135, 15, 150, 65, SHADE_DARK )
   pr_Say( 135, 15, "This text is shaded dark" )


   // Text length
   pr_SetFont( "Times New Roman", 12 )
   cTmp := "This is text is being measured up for a box"
   nTmp := pr_Len( cTmp )
   pr_Box( 200, 15, 200+pt2mm(12), 15+nTmp, LINE_SINGLE, NIL )
   pr_Say( 200, 15, cTmp )
   pr_Say( 205, 15, "Length is "+ltrim(str( nTmp ))+" mm" )


   // Memo processing
   pr_SetFont( "Times New Roman", 12, .f. , .t.  )
   cMemo := ;
   "No man is an island, entire of itself;"                          +CRLF+;
   "every man is a piece of the continent, a part of the main;"      +CRLF+;
   "if a clod be washed away by the sea, Europe is the less,"        +CRLF+;
   "as well as if a promontory were,"                                +CRLF+;
   "as well as if a manor of thy friends or of thine own were;"      +CRLF+;
   "any man's death diminishes me, because I am involved in mankind;"+CRLF+;
   "and therefore never send to know for whom the bell tolls;"       +CRLF+;
   "it tolls for thee."

   pr_Line( 170, 100, 100, NIL, LINE_VERTICAL )
   pr_Line( 170, 190, 100, NIL, LINE_VERTICAL )

   nTmp := pr_JustCount( cMemo, 90 )
   for i := 1 to nTmp
      pr_Say( 170 + ((i-1) * 5), 100, pr_JustLine(i) )
   next

   // And at the end of each page
   pr_Eject( .t. )

   // Clean up
   pr_Reset()

return( NIL )
